//+------------------------------------------------------------------+
//|                                                  TestLoad M1.mq5 |
//|                                  Copyright 2022, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164

double percent = 0;
double priceM1[];
int total_m1 = 0;
datetime timeM1[];
int OnInit()
{
   EventSetMillisecondTimer(50);
   int max_bars = TerminalInfoInteger(TERMINAL_MAXBARS);
   if (max_bars<100000000) Print("Please change the settings of Max bars to ""Unlimited"" and restart the terminal.");
   Print("Start MemoryUsed = "+string(TerminalInfoInteger(TERMINAL_MEMORY_USED)));
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
void OnTick()
{


}
//+------------------------------------------------------------------+
void OnTimer()
{
   if (percent<100) {
      datetime ServerFirstDate = (datetime)SeriesInfoInteger(_Symbol,PERIOD_M1,SERIES_SERVER_FIRSTDATE);
      double close[]; 
      datetime time[];
      datetime last_time;
      if (total_m1>0)
         last_time = timeM1[0]-60;
      else last_time = TimeCurrent()+120;
      int total = CopyClose(_Symbol,PERIOD_M1,last_time,1<<16,close);
      total = CopyTime(_Symbol,PERIOD_M1,last_time,1<<16,time);
      total_m1+=total;
      ArrayResize(priceM1,total_m1);
      ArrayResize(timeM1,total_m1);
      if (total_m1>total) {
         ArrayCopy(priceM1,priceM1,total,0,total_m1-total);
         ArrayCopy(timeM1,timeM1,total,0,total_m1-total);
      }
      ArrayCopy(timeM1,time,0,0,total);
      ArrayCopy(priceM1,close,0,0,total);
      percent =  100.0*(timeM1[total_m1-1]-timeM1[0])/(timeM1[total_m1-1]-ServerFirstDate);
      ArrayFree(time);
      ArrayFree(close);
      Draw();

   } else {
      EventKillTimer();
      ArrayFree(priceM1);
      ArrayFree(timeM1);
      Print("End MemoryUsed = "+string(TerminalInfoInteger(TERMINAL_MEMORY_USED)));
      Print("Total M1 bars = " + string(total_m1));

   }
}
//+------------------------------------------------------------------+
void Draw()
{
   double max = priceM1[ArrayMaximum(priceM1)];
   double min = priceM1[ArrayMinimum(priceM1)];
   Canvas.Erase(0x00FFFFFF0);
   double dx = double(timeM1[total_m1-1]-timeM1[0]);
   for (int i = 1; i<total_m1; i++) Canvas.LineD((W.Width-1)*(timeM1[i-1]-timeM1[0])/dx,W.Height-5-(W.Height-10)*(priceM1[i-1]-min)/(max-min),(W.Width-1)*(timeM1[i]-timeM1[0])/dx,W.Height-5-(W.Height-10)*(priceM1[i]-min)/(max-min),0x80FF2080);
   Canvas.CurentFont("Courier New",50);
   _CommXY(W.Width/5, 50,DoubleToString(percent,2)+" %" +"  MemoryUsed = "+string(TerminalInfoInteger(TERMINAL_MEMORY_USED)));
   Canvas.Update();
}
//+------------------------------------------------------------------+
